//package com.smppw.analysis.domain.manager.performance;
//
//import cn.hutool.core.collection.CollUtil;
//import cn.hutool.core.collection.CollectionUtil;
//import cn.hutool.core.collection.ListUtil;
//import cn.hutool.core.date.DateUtil;
//import cn.hutool.core.lang.Pair;
//import cn.hutool.core.map.MapUtil;
//import cn.hutool.core.util.StrUtil;
//import com.smppw.analysis.domain.dto.performance.BaseParams;
//import com.smppw.analysis.domain.dto.performance.HistoryRetTableSingleData;
//import com.smppw.analysis.domain.dto.performance.HistoryRetTableSingleResp;
//import com.smppw.analysis.domain.dto.performance.HistoryRetTableSingleRet;
//import com.smppw.analysis.domain.service.BaseIndicatorServiceV2;
//import com.smppw.analysis.domain.service.NavService;
//import com.smppw.analysis.infrastructure.exception.APIException;
//import com.smppw.analysis.infrastructure.exception.DataException;
//import com.smppw.common.cache.CaffeineLocalCache;
//import com.smppw.common.pojo.IStrategy;
//import com.smppw.common.pojo.dto.CompoundRet;
//import com.smppw.common.pojo.dto.DateValue;
//import com.smppw.common.pojo.dto.calc.*;
//import com.smppw.common.pojo.dto.indicator.CalcMultipleSecMultipleTimeRangeIndicatorReq;
//import com.smppw.common.pojo.dto.indicator.DateIntervalDto;
//import com.smppw.common.pojo.dto.time.TimeIntervalDto;
//import com.smppw.common.pojo.enums.*;
//import com.smppw.constants.Consts;
//import com.smppw.constants.DateConst;
//import com.smppw.core.reta.IndicatorFactory;
//import com.smppw.core.reta.calc.PerformanceConsistency;
//import com.smppw.utils.BigDecimalUtils;
//import com.smppw.utils.DataUtil;
//import com.smppw.utils.RangeUtils;
//import com.smppw.utils.StrategyHandleUtils;
//import org.apache.commons.lang3.StringUtils;
//import org.apache.commons.lang3.time.DateUtils;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//
//import java.math.BigDecimal;
//import java.math.RoundingMode;
//import java.util.*;
//import java.util.function.BinaryOperator;
//import java.util.function.Function;
//import java.util.stream.Collectors;
//
///**
// * @author wangzaijun
// * @date 2023/3/7 10:05
// * @description 抽象的业绩表现服务，目前仅包含一些模板方法；可能包括基金、经理和机构的业务
// */
//public abstract class AbstractPerformanceService implements PerformanceService {
//    protected static final String YEAR_ROLL_DEFAULT_ID = "YearRoll";
//    protected static final String MONTH_ROLL_DEFAULT_ID = "MonthRoll";
//    protected static final List<String> YEAR_MONTH_ROLL_LIST = ListUtil.of(YEAR_ROLL_DEFAULT_ID, MONTH_ROLL_DEFAULT_ID);
//    private static final Integer GROUP_NUMBER = 10;
//    private static final String ZERO = "0";
//    private static final String EXTRA = "extra";
//    private static final String ALL_TIME = "allTime";
//    private static final Map<Frequency, List<Integer>> CATE_LIST_MAP = MapUtil.newHashMap();
//    private static final Map<Frequency, List<String>> MONTH_WEEK_LIST_MAP = MapUtil.newHashMap();
//    private static final Map<String, Pair<String, String>> MONTH_QUARTERLY_MAP = MapUtil.newHashMap();
//
//    static {
//        CATE_LIST_MAP.put(Frequency.Monthly, ListUtil.toLinkedList(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12));
//        CATE_LIST_MAP.put(Frequency.Weekly, ListUtil.toLinkedList(1, 2, 3, 4, 5));
//        CATE_LIST_MAP.put(Frequency.Quarterly, ListUtil.toLinkedList(1, 2, 3, 4));
//        CATE_LIST_MAP.put(Frequency.Annually, ListUtil.list(true));
//        MONTH_WEEK_LIST_MAP.put(Frequency.Monthly, ListUtil.toLinkedList("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"));
//        MONTH_WEEK_LIST_MAP.put(Frequency.Weekly, ListUtil.toLinkedList("1", "2", "3", "4", "5"));
//        MONTH_WEEK_LIST_MAP.put(Frequency.Quarterly, ListUtil.toLinkedList("03", "06", "09", "12"));
//        MONTH_WEEK_LIST_MAP.put(Frequency.Annually, ListUtil.list(true));
//
//        MONTH_QUARTERLY_MAP.put("01", Pair.of("01", "03"));
//        MONTH_QUARTERLY_MAP.put("02", Pair.of("01", "03"));
//        MONTH_QUARTERLY_MAP.put("03", Pair.of("01", "03"));
//        MONTH_QUARTERLY_MAP.put("04", Pair.of("03", "06"));
//        MONTH_QUARTERLY_MAP.put("05", Pair.of("03", "06"));
//        MONTH_QUARTERLY_MAP.put("06", Pair.of("03", "06"));
//        MONTH_QUARTERLY_MAP.put("07", Pair.of("06", "09"));
//        MONTH_QUARTERLY_MAP.put("08", Pair.of("06", "09"));
//        MONTH_QUARTERLY_MAP.put("09", Pair.of("06", "09"));
//        MONTH_QUARTERLY_MAP.put("10", Pair.of("09", "12"));
//        MONTH_QUARTERLY_MAP.put("11", Pair.of("09", "12"));
//        MONTH_QUARTERLY_MAP.put("12", Pair.of("09", "12"));
//    }
//
//    protected final Logger logger = LoggerFactory.getLogger(AbstractPerformanceService.class);
//    protected final NavService navService;
//    protected final InfoService infoService;
//    protected final SecId2NameService secId2NameService;
//    protected final BaseIndicatorServiceV2 baseIndicatorServiceV2;
//    Map<String, String> indicatorNameMapping = MapUtil.<String, String>builder().put(Indicator.IntervalReturn.name(), "区间收益")
//            .put(Indicator.AnnualReturn.name(), "年化收益")
//            .put(Indicator.SharpeRatio.name(), "夏普比率")
//            .put(Indicator.SortinoRatio.name(), "索提诺比率")
//            .put(Indicator.CalmarRatio.name(), "卡玛比率")
//            .put(Indicator.AnnualStdDev.name(), "年化波动率")
//            .put(Indicator.MaxDrawdown.name(), "最大回撤")
//            .put(Indicator.MaxDrawdownRecureIntervalDays.name(), "最大回撤修复天数")
//            .put(Indicator.DownsideStdDev.name(), "下行风险")
//            .build();
//    @Autowired
//    private CmAccruedNavDao accruedNavDao;
//
//    public AbstractPerformanceService(NavService navService, InfoService infoService, SecId2NameService secId2NameService,
//                                      BaseIndicatorServiceV2 baseIndicatorServiceV2) {
//        this.navService = navService;
//        this.infoService = infoService;
//        this.secId2NameService = secId2NameService;
//        this.baseIndicatorServiceV2 = baseIndicatorServiceV2;
//    }
//
//    /**
//     * 公共参数检验，部分参数为空时设置默认值.
//     *
//     * @param params 请求参数
//     * @param <P>    类型参数
//     */
//    protected <P extends BaseParams> void checkParams(P params) {
//        if (params.getFundId() == null || params.getFundId().isEmpty()) {
//            throw new APIException("fundId 参数不能为空");
//        }
//        if (StrUtil.isBlank(params.getStartDate()) && StrUtil.isBlank(params.getEndDate())) {
//            throw new DataException(null);
//        }
//        if (params.getNavType() == null) {
//            logger.warn(String.format("navType 为null, 设置一个初始值：%s", NavType.CumulativeNav));
//            params.setNavType(NavType.CumulativeNav);
//        }
//        if (params.getFrequency() == null) {
//            logger.warn(String.format("frequency 为null, 设置一个初始值：%s", Frequency.Daily));
//            params.setFrequency(Frequency.Daily);
//        }
//    }
//
//    /**
//     * 策略枚举，从字符串转换。实现类太多不能自动转换需特殊处理
//     */
//    protected <P extends BaseParams> IStrategy getOriginStrategy(P params) {
//        return StrategyHandleUtils.getStrategy(params.getStrategy());
//    }
//
//    /**
//     * 根据请求参数构建 DateIntervalDto 对象
//     *
//     * @param params           请求参数，需继承 CommonParams
//     * @param dateIntervalType 时段类型
//     * @param frequency        接口传递的频率，一般为滚动计算时传递的滚动频率
//     * @param <P>              参数类型
//     * @return /
//     */
//    protected <P extends BaseParams> DateIntervalDto buildDateIntervalByParams(P params, DateIntervalType dateIntervalType, Frequency frequency) {
//        if (dateIntervalType == null) {
//            dateIntervalType = DateIntervalType.DefaultInterval;
//        }
//        if (frequency == null) {
//            frequency = params.getFrequency();
//        }
//        return DateIntervalDto.builder()
//                .id(dateIntervalType.name())
//                .startDate(params.getStartDate())
//                .endDate(params.getEndDate())
//                .timeRange(params.getTimeRange())
//                .dateIntervalType(dateIntervalType)
//                .frequency(frequency).build();
//    }
//
//    /**
//     * 根据请求参数构建 DateIntervalDto 对象  指数还需要额外一个时段的指标
//     *
//     * @param params           请求参数，需继承 CommonParams
//     * @param dateIntervalType 时段类型
//     * @param frequency        接口传递的频率，一般为滚动计算时传递的滚动频率
//     * @param <P>              参数类型
//     * @return /
//     */
//    protected <P extends BaseParams> List<DateIntervalDto> buildIndexDateIntervalByParams(P params, DateIntervalType dateIntervalType, Frequency frequency) {
//        List<DateIntervalDto> res = CollectionUtil.newArrayList();
//        if (frequency == null) {
//            frequency = params.getFrequency();
//        }
//        // 区间指标 时段
//        DateIntervalDto dateIntervalDto = DateIntervalDto.builder()
//                .id(dateIntervalType.name())
//                .startDate(params.getStartDate())
//                .endDate(params.getEndDate())
//                .timeRange(params.getTimeRange())
//                .dateIntervalType(dateIntervalType)
//                .frequency(frequency).build();
//        res.add(dateIntervalDto);
//        // 根据用户选择时段切换 计算指标
//        DateIntervalDto customInterval = DateIntervalDto.builder()
//                .id(dateIntervalType.name())
//                .startDate(params.getStartDate())
//                .endDate(params.getEndDate())
//                .timeRange(TimeRange.Custom)
//                .dateIntervalType(DateIntervalType.CustomInterval)
//                .frequency(frequency).build();
//        res.add(customInterval);
//        return res;
//    }
//
//    /**
//     * 从请求参数中获取所有标的并集集合
//     *
//     * @param params 公共请求参数
//     * @param <P>    类型
//     * @return /
//     */
//    protected <P extends BaseParams> List<String> getSecIdsByParams(P params) {
//        List<String> tempList = ListUtil.list(true);
//        tempList.addAll(params.getFundId());
//        if (StrUtil.isNotBlank(params.getBenchmarkId())) {
//            tempList.add(params.getBenchmarkId());
//        }
//        return params.getSecIds() == null ? tempList : CollUtil.addAllIfNotContains(tempList, params.getSecIds());
//    }
//
//    /**
//     * 构建指标计算参数
//     *
//     * @param params          接口请求参数
//     * @param indicators      要计算的普通指标
//     * @param geoIndicators   geo指标
//     * @param dateIntervalMap 时段
//     * @param <P>             类型参数
//     * @return /
//     */
//    private <P extends BaseParams> CalcMultipleSecMultipleTimeRangeIndicatorReq buildCalcReq(P params, List<Indicator> indicators, List<Indicator> geoIndicators, Map<String, List<DateIntervalDto>> dateIntervalMap) {
//        List<String> refIds = params.getFundId();
//        List<String> secIds = this.getSecIdsByParams(params);
//        // 差集求指数id集合，包括基准
//        List<String> indexIds = CollectionUtil.subtractToList(secIds, refIds);
//        Map<String, String> benchmarkIdMap = MapUtil.newHashMap(true);
//        for (String refId : refIds) {
//            if (StrUtil.isBlank(params.getBenchmarkId())) {
//                continue;
//            }
//            benchmarkIdMap.put(refId, params.getBenchmarkId());
//        }
//        return CalcMultipleSecMultipleTimeRangeIndicatorReq.builder()
//                .mainSecIdList(refIds)
//                .secBenchmarkIdMap(benchmarkIdMap)
//                .indexIdList(indexIds)
//                .raiseType(params.getRaiseType())
//                .strategy(this.getOriginStrategy(params))
//                .visibility(Visibility.Both)
//                .dataFrequency(params.getFrequency())
//                .navType(params.getNavType())
//                .secDateIntervalDtoListMap(dateIntervalMap)
//                .indicatorList(indicators)
//                .geoExtraindicatorList(geoIndicators)
//                .ifAnnualize(true)
//                .calcIndexRetIndicatorValue(true)
//                .ifConvertPerformanceConsistencyWord(true).build();
//    }
//
//    /**
//     * 构建指标计算请求参数
//     *
//     * @param params           /
//     * @param indicatorList    要计算的普通指标列表
//     * @param geoIndicatorList 几何指标列表
//     * @param dateIntervalType /
//     * @param frequency        /
//     * @param <P>              /
//     * @return /
//     */
//    protected <P extends BaseParams> CalcMultipleSecMultipleTimeRangeIndicatorReq buildCalcReq(P params, List<Indicator> indicatorList, List<Indicator> geoIndicatorList,
//                                                                                               DateIntervalType dateIntervalType, Frequency frequency) {
//        List<String> refIds = params.getFundId();
//        DateIntervalDto dateInterval = this.buildDateIntervalByParams(params, dateIntervalType, frequency);
//        Map<String, List<DateIntervalDto>> dateIntervalMap = MapUtil.newHashMap(true);
//        for (String refId : refIds) {
//            dateIntervalMap.put(refId, ListUtil.toList(dateInterval));
//        }
//        return this.buildCalcReq(params, indicatorList, geoIndicatorList, dateIntervalMap);
//    }
//
//    /**
//     * 特殊处理的数据
//     *
//     * @param params           /
//     * @param indicatorList    /
//     * @param rollingFrequency /
//     * @param <P>              /
//     * @return /
//     */
//    protected <P extends BaseParams> CalcMultipleSecMultipleTimeRangeIndicatorReq buildCalcReq(P params, List<Indicator> indicatorList, List<Indicator> geoIndicatorList, Frequency rollingFrequency) {
//        List<String> refIds = params.getFundId();
//        String startDate = params.getStartDate();
//        String endDate = params.getEndDate();
//        List<DateIntervalDto> dateIntervalDtoList = new ArrayList<>();
//        DateIntervalDto dateIntervalDto = new DateIntervalDto();
//        dateIntervalDto.setDateIntervalType(DateIntervalType.DefaultRolling);
//        dateIntervalDto.setStartDate(startDate);
//        dateIntervalDto.setEndDate(endDate);
//        dateIntervalDto.setFrequency(rollingFrequency);
//        dateIntervalDtoList.add(dateIntervalDto);
//        if (Frequency.Monthly == rollingFrequency || Frequency.Quarterly == rollingFrequency) {
//            DateIntervalDto yearDateIntervalDto = new DateIntervalDto();
//            yearDateIntervalDto.setDateIntervalType(DateIntervalType.DefaultRolling);
//            yearDateIntervalDto.setStartDate(startDate);
//            yearDateIntervalDto.setEndDate(endDate);
//            yearDateIntervalDto.setFrequency(Frequency.Annually);
//            yearDateIntervalDto.setId(YEAR_ROLL_DEFAULT_ID);
//            dateIntervalDtoList.add(yearDateIntervalDto);
//        } else if (Frequency.Weekly == rollingFrequency) {
//            DateIntervalDto monthDateIntervalDto = new DateIntervalDto();
//            monthDateIntervalDto.setDateIntervalType(DateIntervalType.DefaultRolling);
//            monthDateIntervalDto.setStartDate(startDate);
//            monthDateIntervalDto.setEndDate(endDate);
//            monthDateIntervalDto.setFrequency(Frequency.Monthly);
//            monthDateIntervalDto.setId(MONTH_ROLL_DEFAULT_ID);
//            dateIntervalDtoList.add(monthDateIntervalDto);
//        }
//        Map<String, List<DateIntervalDto>> dateIntervalMap = MapUtil.newHashMap(true);
//        for (String refId : refIds) {
//            dateIntervalMap.put(refId, dateIntervalDtoList);
//        }
//        return this.buildCalcReq(params, indicatorList, geoIndicatorList, dateIntervalMap);
//    }
//
//    /**
//     * 走势图 公共逻辑处理
//     *
//     * @param params          请求参数，公共部分
//     * @param trendTypes      要获取的走势图集合
//     * @param indexTrendTypes 指数要获取的走势集合
//     * @param <P>             类型参数
//     * @return /
//     */
//    @SuppressWarnings("unchecked")
//    protected <P extends BaseParams> CommonData<Map<String, List<Map<String, Object>>>> handleTrends(P params, List<TrendType> trendTypes, List<TrendType> indexTrendTypes, String masterId) {
//        // 1、参数处理
//        this.checkParams(params);
//        boolean multiSec = params.multiSec();
//        List<String> refIds = params.getFundId();
//        List<String> secIds = this.getSecIdsByParams(params);
//        List<String> indexIds = CollectionUtil.subtractToList(secIds, refIds);
//
//        // 时段参数构建
//        DateIntervalDto dateInterval = this.buildDateIntervalByParams(params, DateIntervalType.CustomInterval, null);
//        Map<String, String> benchmarkIdMap = MapUtil.newHashMap(true);
//        for (String refId : refIds) {
//            if (StrUtil.isBlank(params.getBenchmarkId())) {
//                continue;
//            }
//            benchmarkIdMap.put(refId, params.getBenchmarkId());
//        }
//
//        // 计算走势图
//        Map<String, List<IndicatorCalcPropertyDto>> trendMap = this.baseIndicatorServiceV2.getMultipleSecTrend(refIds, benchmarkIdMap,
//                indexIds, dateInterval, params.getFrequency(), null, null, params.getRaiseType(), this.getOriginStrategy(params),
//                Visibility.Both, params.getNavType(), trendTypes, isExtract, userId);
//
//        // 结果处理，支持多标的
//        // 处理走势图
//        Map<String, List<Map<String, Object>>> dataListMap = MapUtil.newHashMap(true);
//        Map<String, List<Map<String, Object>>> indexDataListMap = MapUtil.newHashMap(true);
//        Map<String, Map<String, Object>> trendListMap = MapUtil.newHashMap(true);
//        Map<String, Map<String, Object>> indexTrendListMap = MapUtil.newHashMap(true);
//        for (String refId : refIds) {
//            IndicatorCalcPropertyDto dto = Optional.ofNullable(trendMap.get(refId)).filter(e -> !e.isEmpty()).map(e -> e.get(0)).orElse(null);
//            List<String> tempDateList = Optional.ofNullable(dto).map(IndicatorCalcPropertyDto::getDateList).orElse(ListUtil.empty());
//            // 基金走势序列
//            Map<TrendType, List<Double>> tempTrendTypeListMap = Optional.ofNullable(dto).map(IndicatorCalcPropertyDto::getSecData).map(IndicatorCalcSecDataDto::getTrendValueMap).orElse(MapUtil.empty());
//            trendListMap.put(refId, MapUtil.<String, Object>builder().put("dates", tempDateList).put("trend", tempTrendTypeListMap).build());
//            dataListMap.put(refId, this.buildDateValue(tempDateList, tempTrendTypeListMap, trendTypes));
//            if (masterId == null && multiSec) {
//                // 多标的的 走势图 不绘制基准走势
//                continue;
//            }
//            // 指数净值和收益序列
//            Map<String, Map<TrendType, List<Double>>> tempIndexTrendTypeListMap = Optional.ofNullable(dto).map(IndicatorCalcPropertyDto::getIndexData).map(IndicatorCalcIndexDataDto::getIndexTrendValueMap).orElse(MapUtil.empty());
//            for (String indexId : indexIds) {
//                if (indexDataListMap.containsKey(indexId) && !indexId.equals(params.getBenchmarkId())) {
//                    continue;
//                }
//                indexTrendListMap.put(indexId, MapUtil.<String, Object>builder().put("dates", tempDateList).put("trend", tempIndexTrendTypeListMap.get(indexId)).build());
//                indexDataListMap.put(indexId, this.buildDateValue(tempDateList, tempIndexTrendTypeListMap.get(indexId), indexTrendTypes));
//            }
//        }
//        Map<String, List<Map<String, Object>>> valuesMap = this.multiSecMergeDateValue(refIds, trendMap, dataListMap, trendTypes, multiSec);
//
//        Map<String, List<Map<String, Object>>> dataset = MapUtil.<String, List<Map<String, Object>>>builder().putAll(valuesMap).build();
//        Map<String, String> productNameMapping = this.secId2NameService.query(secIds);
//        Map<String, Object> extInfos = MapUtil.<String, Object>builder().put("endDate", params.getEndDate()).put("startDate", params.getStartDate()).build();
//        if (masterId != null || !multiSec) {
//            // 求基金和基准的年化收益率
//            String fundId = refIds.get(0);
//            Map<String, Object> map = trendListMap.get(fundId);
//            Map<String, Object> indexMap = Optional.ofNullable(indexTrendListMap.get(params.getBenchmarkId())).orElse(MapUtil.newHashMap());
//            List<String> dateList = MapUtil.get(map, "dates", List.class);
//            Map<TrendType, List<Double>> trendTypeListMap = MapUtil.get(map, "trend", Map.class);
//            Map<TrendType, List<Double>> indexTrendTypeListMap = Optional.ofNullable(MapUtil.get(indexMap, "trend", Map.class)).orElse(MapUtil.newHashMap());
//            List<DateValue> dateValues = this.buildDateValue(dateList, trendTypeListMap.get(TrendType.Nav));
//            List<DateValue> indexDateValues = this.buildDateValue(dateList, indexTrendTypeListMap.get(TrendType.OrigNav));
//            Double annual = IndicatorFactory.getInstance().get(Indicator.AnnualReturn).calc(dateValues);
//            Double annualBenchmark = IndicatorFactory.getInstance().get(Indicator.AnnualReturn).calc(indexDateValues);
//            // 求最大回撤和超额最大回撤，业绩走势图不返回
//            Double maxDown = this.handleMaxAndMin(trendTypeListMap.get(TrendType.DrawdownTrend), (o1, o2) -> o1 > o2 ? o2 : o1);
//            Double maxExtraDown = this.handleMaxAndMin(trendTypeListMap.get(TrendType.ExtraDrawdownTrend), (o1, o2) -> o1 > o2 ? o2 : o1);
//            Map<String, Object> extInfos1 = MapUtil.<String, Object>builder("maxDown", maxDown).put("maxExtraDown", maxExtraDown)
//                    .put("annual", annual).put("annualBenchmark", annualBenchmark).build();
//            extInfos.putAll(extInfos1);
//            dataset.putAll(indexDataListMap);
//        }
//        return CommonData.<Map<String, List<Map<String, Object>>>>builder().dataset(dataset).productNameMapping(productNameMapping).extInfos(extInfos).build();
//    }
//
//    private void AddAccruedNav(Map<String, List<Map<String, Object>>> valuesMap) {
//        valuesMap.forEach((k, v) -> {
//            //获取基金的复权净值序列
//            Map<String, List<DateValue>> allNavMap = navService.getSecIdDateValueNavListMapFromRedisAndDB(CollUtil.toList(k), CollUtil.newArrayList(), CollUtil.newArrayList(),
//                    null, null, NavType.CumulativeNav, Visibility.Visible, null, null, new HashMap<>(0), false, null);
//            List<DateValue> fundNavList = allNavMap.get(k);
//            if (CollUtil.isNotEmpty(fundNavList)) {
//                Map<String, DateValue> cmAccruedNavDoMap = fundNavList.stream()
//                        .collect(Collectors.toMap(e -> e.getDate(), e -> e));
//                if (CollUtil.isNotEmpty(v)) {
//                    v.forEach(e -> {
//                        String date = (String) e.get("date");
//                        e.put("accruedNav", e.get("Nav"));
//                        DateValue dateValue = cmAccruedNavDoMap.get(date);
//                        e.put("Nav", dateValue == null ? null : dateValue.getValue());
//                    });
//                }
//            }
//        });
//    }
//
//    private Map<String, List<Map<String, Object>>> multiSecMergeDateValue(List<String> refIds, Map<String, List<IndicatorCalcPropertyDto>> trendMap,
//                                                                          Map<String, List<Map<String, Object>>> dataListMap, List<TrendType> trendTypes, boolean multiSec) {
//        Map<String, List<Map<String, Object>>> valuesMap = MapUtil.newHashMap(true);
//        if (multiSec) {
//            // 日期合并
//            List<String> dateList = ListUtil.list(true);
//            for (String refId : refIds) {
//                IndicatorCalcPropertyDto dto = Optional.ofNullable(trendMap.get(refId)).filter(e -> !e.isEmpty()).map(e -> e.get(0)).orElse(null);
//                List<String> tempDateList = Optional.ofNullable(dto).map(IndicatorCalcPropertyDto::getDateList).orElse(ListUtil.empty());
//                CollUtil.addAllIfNotContains(dateList, tempDateList);
//            }
//            dateList.sort(String::compareTo);
//            // 多标的对比时合并日期，只处理多标的，不管基准和对比指数
//            for (String refId : refIds) {
//                List<Map<String, Object>> maps = dataListMap.get(refId);
//                List<Map<String, Object>> values = dateList.stream().map(e -> {
//                    Map<String, Object> temp = MapUtil.newHashMap();
//                    Map<String, Object> map = maps.stream().filter(o -> e.equals(MapUtil.getStr(o, "date"))).findFirst().orElse(null);
//                    if (map == null || map.isEmpty()) {
//                        for (TrendType trendType : trendTypes) {
//                            temp.put(trendType.name(), null);
//                        }
//                    } else {
//                        temp.putAll(map);
//                    }
//                    temp.put("date", e);
//                    return temp;
//                }).collect(Collectors.toList());
//                valuesMap.put(refId, values);
//            }
//        } else {
//            valuesMap.putAll(dataListMap);
//        }
//        return valuesMap;
//    }
//
//    /**
//     * 滚动指标 时间字段特殊处理
//     *
//     * @param date             时间
//     * @param rollingFrequency 滚动频率
//     * @return /
//     */
//    protected String handleStrDate(String date, Frequency rollingFrequency) {
//        if (rollingFrequency == Frequency.Weekly) {
//            String yearMonthWeek = CaffeineLocalCache.getDateMonthWeek(date);
//            String year = yearMonthWeek.substring(0, 4);
//            String month = yearMonthWeek.substring(5, 7);
//            if (month.startsWith(ZERO)) {
//                month = month.substring(1);
//            }
//            String week = yearMonthWeek.substring(8);
//            return year + "年" + month + "月第" + week + "周";
//        }
//        return date;
//    }
//
//    /**
//     * 处理最大回撤问题，是否已恢复
//     *
//     * @param indicatorValues 指标结果
//     * @param secId           标的id
//     * @param benchmarkId     基准
//     * @param geo             是否处理geo几何指标
//     * @return 新map
//     */
//    protected Map<String, String> handleMaxDrawdown(Map<String, String> indicatorValues, String secId, String benchmarkId, boolean geo) {
//        Map<String, String> result = MapUtil.newHashMap();
//        String maxDrawdown = indicatorValues.get(Indicator.MaxDrawdown.name());
//        String consistency = indicatorValues.get(Indicator.PerformanceConsistency.name());
//        if (StrUtil.isNotBlank(maxDrawdown) && new BigDecimal(maxDrawdown).compareTo(BigDecimal.ZERO) > 0) {
//            if (StrUtil.isBlank(indicatorValues.get(Indicator.MaxDrawdownRecureDate.name()))) {
//                indicatorValues.put(Indicator.MaxDrawdownRecureDate.name(), "最大回撤未修复");
//            }
//            if (StrUtil.isBlank(indicatorValues.get(Indicator.MaxDrawdownRecureIntervalDays.name()))) {
//                indicatorValues.put(Indicator.MaxDrawdownRecureIntervalDays.name(), "最大回撤未修复");
//            }
//            if (StrUtil.isBlank(indicatorValues.get(Indicator.MaxDrawdownRecureInterval.name()))) {
//                indicatorValues.put(Indicator.MaxDrawdownRecureInterval.name(), "最大回撤未修复");
//            }
//        }
//        if (StringUtils.isEmpty(consistency)) {
//            indicatorValues.put(Indicator.PerformanceConsistency.name(), PerformanceConsistency.convert2Word(null));
//        } else {
//            indicatorValues.put(Indicator.PerformanceConsistency.name(), PerformanceConsistency.convert2Word(Double.parseDouble(consistency)));
//        }
//        if (geo) {
//            indicatorValues.forEach((k, v) -> result.put("geoExcess" + k, secId != null && secId.equals(benchmarkId) ? null : v));
//        } else {
//            result.putAll(indicatorValues);
//        }
//        return result;
//    }
//
//    /**
//     * 指标分析核心业务逻辑   这种业务代码不要抽象到这里 两处的业务只要有一处改动 这里就没法复用
//     *
//     * @param params           请求参数
//     * @param indicator        分析的指标
//     * @param dateIntervalType 日期类型
//     * @param excess           是否计算超额
//     * @param rollingFrequency 滚动频率，滚动指标分析时有值
//     * @param function         日期字段映射函数
//     * @param <P>              类型参数
//     * @return /
//     */
//    protected <P extends BaseParams> CommonData<Map<String, Object>> analyzeIndicator(P params, Indicator indicator, DateIntervalType dateIntervalType, boolean excess,
//                                                                                      Frequency rollingFrequency, Function<IndicatorCalcTimeRangeDto, String> function) {
//        // 1.参数处理
//        this.checkParams(params);
//        List<String> refIds = params.getFundId();
//        List<String> secIds = this.getSecIdsByParams(params);
//        List<String> indexIds = CollectionUtil.subtractToList(secIds, refIds);
//        List<Indicator> indicators = ListUtil.toList(Indicator.MaxDrawdown);
//        List<Indicator> geoIndicators = ListUtil.list(false);
//        if (excess) {
//            geoIndicators.add(indicator);
//        } else {
//            indicators.add(indicator);
//        }
//        CalcMultipleSecMultipleTimeRangeIndicatorReq req;
//        if (dateIntervalType == DateIntervalType.DefaultRolling) {
//            req = this.buildCalcReq(params, indicators, geoIndicators, rollingFrequency);
//        } else {
//            req = this.buildCalcReq(params, indicators, geoIndicators, dateIntervalType, rollingFrequency);
//        }
//        req.setRiskOfFreeId(Consts.RISK_OF_FREE);
//
//        // 2、指标计算
//        Map<String, List<IndicatorCalcPropertyDto>> indicatorMap = this.baseIndicatorServiceV2.calcMultipleSecMultipleTimeRangeIndicator(req);
//
//        // 3、结果处理
//        Map<TimeRange, Boolean> timeRangeFlag = MapUtil.newHashMap();
//        Map<String, Object> valuesMap = MapUtil.newHashMap(true);
//        Map<String, Object> indexValuesMap = MapUtil.newHashMap(true);
//        for (String refId : refIds) {
//            List<IndicatorCalcPropertyDto> dtos = Optional.ofNullable(indicatorMap.get(refId)).filter(e -> !e.isEmpty()).orElse(ListUtil.empty());
//            // 当前基金的数据处理
//            List<Map<String, Object>> fundIndicatorList = getFundIndicatorList(params, indicator, excess, rollingFrequency, function, timeRangeFlag, dtos);
//            valuesMap.put(refId, fundIndicatorList);
//            // 指数的数据处理
//            if (excess) {
//                continue;
//            }
//            handleIndexData(indicator, rollingFrequency, function, indexIds, timeRangeFlag, indexValuesMap, dtos);
//        }
//        Map<String, Object> dataset = MapUtil.<String, Object>builder().putAll(valuesMap).putAll(indexValuesMap).build();
//
//        Map<String, String> productNameMapping = this.secId2NameService.query(secIds);
//        if (excess) {
//            for (String indexId : indexIds) {
//                productNameMapping.remove(indexId);
//            }
//        }
//        Map<String, Object> extInfos = MapUtil.<String, Object>builder("endDate", params.getEndDate()).put("startDate", params.getStartDate()).build();
//        if (dateIntervalType == DateIntervalType.DefaultRolling) {
//            HistoryRetTableSingleResp resp = getHistoryRetTableSingleResp(refIds, indexIds, indicatorMap, indicator, excess, rollingFrequency);
//            extInfos.put("table", this.buildTableData(productNameMapping, resp, excess, true));
//        }
//        return CommonData.<Map<String, Object>>builder().dataset(dataset).productNameMapping(productNameMapping).extInfos(extInfos).build();
//    }
//
//    private void handleIndexData(Indicator indicator, Frequency rollingFrequency, Function<IndicatorCalcTimeRangeDto, String> function, List<String> indexIds,
//                                 Map<TimeRange, Boolean> timeRangeFlag, Map<String, Object> indexValuesMap, List<IndicatorCalcPropertyDto> dtos) {
//        for (String indexId : indexIds) {
//            if (indexValuesMap.containsKey(indexId)) {
//                continue;
//            }
//            List<Map<String, Object>> indexIndicatorList = ListUtil.list(true);
//            for (IndicatorCalcPropertyDto dto : dtos) {
//                String id = Optional.ofNullable(dto.getIndicatorCalcReq()).map(IndicatorCalcReqPropertyDto::getIndicatorCalcTimeRangeDto).map(IndicatorCalcTimeRangeDto::getId).orElse(null);
//                String date = Optional.ofNullable(dto.getIndicatorCalcReq()).map(IndicatorCalcReqPropertyDto::getIndicatorCalcTimeRangeDto).map(function).orElse(null);
//                TimeRange timeRange = Optional.ofNullable(dto.getIndicatorCalcReq()).map(IndicatorCalcReqPropertyDto::getIndicatorCalcTimeRangeDto).map(IndicatorCalcTimeRangeDto::getTimeRange).orElse(null);
//                boolean yearMonthFlag = (id != null && YEAR_MONTH_ROLL_LIST.contains(id));
//                boolean tf = timeRange == null || timeRangeFlag.getOrDefault(timeRange, false);
//                boolean flag = yearMonthFlag || tf;
//                if (flag || date == null) {
//                    continue;
//                }
//                String value = Optional.ofNullable(dto.getIndexData()).map(IndicatorCalcIndexDataDto::getIndexIndicatorValueMap).map(e -> e.get(indexId)).map(e -> e.get(indicator.name())).orElse(null);
//                indexIndicatorList.add(MapUtil.<String, Object>builder("date", this.handleStrDate(date, rollingFrequency)).put("value", value).build());
//            }
//            indexValuesMap.put(indexId, indexIndicatorList);
//        }
//    }
//
//    private <P extends BaseParams> List<Map<String, Object>> getFundIndicatorList(P params, Indicator indicator, boolean excess, Frequency rollingFrequency,
//                                                                                  Function<IndicatorCalcTimeRangeDto, String> function, Map<TimeRange, Boolean> timeRangeFlag, List<IndicatorCalcPropertyDto> dtos) {
//        List<Map<String, Object>> fundIndicatorList = ListUtil.list(true);
//        for (IndicatorCalcPropertyDto dto : dtos) {
//            String date = Optional.ofNullable(dto.getIndicatorCalcReq()).map(IndicatorCalcReqPropertyDto::getIndicatorCalcTimeRangeDto).map(function).orElse(null);
//            String id = Optional.ofNullable(dto.getIndicatorCalcReq()).map(IndicatorCalcReqPropertyDto::getIndicatorCalcTimeRangeDto).map(IndicatorCalcTimeRangeDto::getId).orElse(null);
//            TimeRange timeRange = Optional.ofNullable(dto.getIndicatorCalcReq()).map(IndicatorCalcReqPropertyDto::getIndicatorCalcTimeRangeDto).map(IndicatorCalcTimeRangeDto::getTimeRange).orElse(null);
//            boolean flag = (id != null && YEAR_MONTH_ROLL_LIST.contains(id));
//            if (timeRange == null || flag) {
//                continue;
//            }
//            if (params.getTimeRange() != null && params.getTimeRange() == TimeRange.Custom) {
//                String start = Optional.ofNullable(dto.getIndicatorCalcReq()).map(IndicatorCalcReqPropertyDto::getIndicatorCalcTimeRangeDto).map(IndicatorCalcTimeRangeDto::getStartDate).orElse(null);
//                boolean isNotNull = params.getStartDate() != null && start != null;
//                if (isNotNull && params.getStartDate().compareTo(start) > 0) {
//                    timeRangeFlag.put(timeRange, true);
//                    continue;
//                }
//            }
//            boolean isFromSetup = params.getTimeRange() != null && params.getTimeRange() != TimeRange.FromSetup;
//            boolean isFromThisYear = params.getTimeRange() != null && params.getTimeRange() != TimeRange.FromThisYear;
//            boolean isCustom = params.getTimeRange() != null && params.getTimeRange() != TimeRange.Custom;
//            boolean isOver = params.getTimeRange() != null && params.getTimeRange().getId() < timeRange.getId();
//            boolean isTimaRange = isFromSetup && isFromThisYear && isCustom && isOver;
//            if (isTimaRange || date == null) {
//                timeRangeFlag.put(timeRange, true);
//                continue;
//            }
//            String value = Optional.ofNullable(dto.getSecData()).map(e -> excess ? e.getExtraGeoIndicatorValueMap() : e.getIndicatorValueMap()).map(e -> e.get(indicator.name())).orElse(null);
//            fundIndicatorList.add(MapUtil.<String, Object>builder("date", this.handleStrDate(date, rollingFrequency)).put("value", value).build());
//        }
//        return fundIndicatorList;
//    }
//
//
//    /**
//     * 构建年度统计表格数据
//     *
//     * @param productNameMapping 名称映射
//     * @param resp               数据
//     * @return /
//     */
//    protected Map<String, Object> buildTableData(Map<String, String> productNameMapping, HistoryRetTableSingleResp resp, boolean excess, boolean flag) {
//        List<Map<String, Object>> data = ListUtil.list(true);
//        for (HistoryRetTableSingleData datum : resp.getData()) {
//            String year = datum.getYear();
//            if (excess && flag) {
//                List<HistoryRetTableSingleRet> collect = datum.getRets().stream().filter(e -> "extraRet".equals(e.getType())).collect(Collectors.toList());
//                for (HistoryRetTableSingleRet ret : collect) {
//                    Map<String, Object> temp = MapUtil.<String, Object>builder("year", year)
//                            .put("name", productNameMapping.get(ret.getId()))
//                            .put("ret", ret.getRet()).build();
//                    data.add(temp);
//                }
//            } else {
//                for (HistoryRetTableSingleRet ret : datum.getRets()) {
//                    Map<String, Object> temp = MapUtil.<String, Object>builder("year", year)
//                            .put("name", "ret".equals(ret.getType()) ? productNameMapping.get(ret.getId()) : productNameMapping.get(ret.getId()) + "-超额收益")
//                            .put("ret", ret.getRet()).build();
//                    data.add(temp);
//                }
//            }
//        }
//        return MapUtil.<String, Object>builder("datetime", resp.getDatetime()).put("data", data).build();
//    }
//
//    /**
//     * 胜率业务处理，从老项目迁移过来
//     *
//     * @param id      /
//     * @param winRate /
//     * @param retList /
//     * @param winZero /
//     * @return /
//     */
//    protected Map<String, String> prepareWinRateData(String id, String winRate, List<CompoundRet> retList, boolean winZero) {
//        Map<String, String> timeMap = MapUtil.builder("allTime", "全时段").put("riseTime", "上涨周期")
//                .put("fallTime", "下跌周期").put("shockTime", "震荡周期").build();
//        List<Double> fundList = new ArrayList<>();
//        List<Double> bmkList = new ArrayList<>();
//        int winItem = 0;
//        int lossItem = 0;
//        int totalItem = 0;
//        for (CompoundRet compoundRet : retList) {
//            if (compoundRet.getRetOfBmk() == null) {
//                if (winZero && compoundRet.getRetOfFund() != null) {
//                    compoundRet.setRetOfBmk(0.d);
//                } else {
//                    continue;
//                }
//            }
//            fundList.add(compoundRet.getRetOfFund());
//            bmkList.add(compoundRet.getRetOfBmk());
//            if (winZero) {
//                if (compoundRet.getRetOfFund() != null) {
//                    if ((compoundRet.getRetOfFund() - 0) > 0) {
//                        winItem++;
//                    } else {
//                        lossItem++;
//                    }
//                    totalItem++;
//                }
//            } else {
//                if (compoundRet.getRetOfFund() != null && compoundRet.getRetOfBmk() != null) {
//                    if (compoundRet.getRetOfFund() - compoundRet.getRetOfBmk() > 0) {
//                        winItem++;
//                    } else {
//                        lossItem++;
//                    }
//                    totalItem++;
//                }
//            }
//        }
//
//        Map<String, String> map = MapUtil.newHashMap();
//        if (ALL_TIME.equals(id)) {
//            map.put("winRate", winRate);
//        } else {
//            if (totalItem == 0) {
//                map.put("winRate", "0");
//            } else {
//                map.put("winRate", BigDecimalUtils.divide(new BigDecimal(winItem), new BigDecimal(totalItem)).setScale(4, RoundingMode.HALF_UP).toString());
//            }
//        }
//        Double meanFundRet = meanRetCal(fundList);
//        map.put("meanRet", number2String(meanFundRet));
//        Double meanBenchmarkRet = meanRetCal(bmkList);
//        map.put("benchmarkMeanRet", number2String(meanFundRet));
//        Double excessMeanRet = null;
//        if (null != meanFundRet && null != meanBenchmarkRet) {
//            excessMeanRet = meanFundRet - meanBenchmarkRet;
//        }
//        map.put("excessMeanRet", number2String(excessMeanRet));
//        map.put("winItem", winItem + "");
//        map.put("lossItem", lossItem + "");
//        map.put("totalItem", totalItem + "");
//        map.put("dateType", timeMap.get(id));
//        return map;
//    }
//
//    private String number2String(Double value) {
//        if (null != value) {
//            return value + "";
//        }
//        return null;
//    }
//
//    private Double meanRetCal(List<Double> list) {
//        double sum = 0.0;
//        int couter = 0;
//
//        for (Double d : list) {
//            if (null != d) {
//                sum += d;
//                couter++;
//            }
//        }
//
//        if (couter < 1) {
//            return null;
//        }
//
//        return sum / couter;
//    }
//
//    /**
//     * 获取分布图，已支持多标的
//     *
//     * @param refIds         基金id，支持多标的
//     * @param indexIdList    指数id列表，包括基准
//     * @param dtoMap         计算返回数据
//     * @param space          分布图横坐标间距
//     * @param ifExcessReturn 是否计算超额
//     * @return /
//     */
//    protected Map<String, Object> loadDistributionData(List<String> refIds, List<String> indexIdList, Map<String, List<IndicatorCalcPropertyDto>> dtoMap, double space, boolean ifExcessReturn) {
//        Map<String, Object> valuesMap = MapUtil.newHashMap(true);
//        Map<String, Object> indexValuesMap = MapUtil.newHashMap(true);
//        double maxValue = 0d;
//        double minValue = 0d;
//        for (String refId : refIds) {
//            List<Double> indicatorValues = dtoMap.get(refId).stream()
//                    .filter(p -> !YEAR_MONTH_ROLL_LIST.contains(p.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getId()))
//                    .map(IndicatorCalcPropertyDto::getSecData)
//                    .map(e -> ifExcessReturn ? e.getExtraGeoIndicatorValueMap() : e.getIndicatorValueMap())
//                    .map(e -> e.get(Indicator.IntervalReturn.name())).filter(Objects::nonNull).map(Double::parseDouble).collect(Collectors.toList());
//            List<Map<String, Map<String, String>>> collect = dtoMap.get(refId).stream()
//                    .filter(p -> !YEAR_MONTH_ROLL_LIST.contains(p.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getId()))
//                    .map(IndicatorCalcPropertyDto::getIndexData)
//                    .map(IndicatorCalcIndexDataDto::getIndexIndicatorValueMap).collect(Collectors.toList());
//            maxValue = Math.max(maxValue, this.handleMaxAndMin(indicatorValues, (o1, o2) -> o1 > o2 ? o1 : o2));
//            minValue = Math.min(minValue, this.handleMaxAndMin(indicatorValues, (o1, o2) -> o1 > o2 ? o2 : o1));
//            for (String indexId : indexIdList) {
//                List<Double> indexIndicatorValues = collect.stream().map(e -> e.get(indexId)).map(e -> e.get(Indicator.IntervalReturn.name()))
//                        .filter(Objects::nonNull).map(Double::parseDouble).collect(Collectors.toList());
//                maxValue = Math.max(maxValue, this.handleMaxAndMin(indexIndicatorValues, (o1, o2) -> o1 > o2 ? o1 : o2));
//                minValue = Math.min(minValue, this.handleMaxAndMin(indexIndicatorValues, (o1, o2) -> o1 > o2 ? o2 : o1));
//            }
//        }
//        for (String refId : refIds) {
//            List<Double> indicatorValues = dtoMap.get(refId).stream()
//                    .filter(p -> !YEAR_MONTH_ROLL_LIST.contains(p.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getId()))
//                    .map(IndicatorCalcPropertyDto::getSecData)
//                    .map(e -> ifExcessReturn ? e.getExtraGeoIndicatorValueMap() : e.getIndicatorValueMap())
//                    .map(e -> e.get(Indicator.IntervalReturn.name())).filter(Objects::nonNull).map(Double::parseDouble).collect(Collectors.toList());
//            List<Pair<Double, Double>> dates = RangeUtils.groupNumberLimitCondition(GROUP_NUMBER, space, minValue, maxValue);
//            valuesMap.put(refId, DataUtil.buildValue(dates, indicatorValues));
//            for (String indexId : indexIdList) {
//                if (indexValuesMap.containsKey(indexId)) {
//                    continue;
//                }
//                List<Double> indexIndicatorValues = dtoMap.get(refId).stream()
//                        .filter(p -> !YEAR_MONTH_ROLL_LIST.contains(p.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getId()))
//                        .map(IndicatorCalcPropertyDto::getIndexData)
//                        .map(IndicatorCalcIndexDataDto::getIndexIndicatorValueMap).map(e -> e.get(indexId)).map(e -> e.get(Indicator.IntervalReturn.name()))
//                        .filter(Objects::nonNull).map(Double::parseDouble).collect(Collectors.toList());
//                indexValuesMap.put(indexId, DataUtil.buildValue(dates, indexIndicatorValues));
//            }
//        }
//        return MapUtil.<String, Object>builder().putAll(valuesMap).putAll(indexValuesMap).build();
//    }
//
//    /**
//     * 利用jdk8的流操作计算最大最小值
//     *
//     * @param dataList 待计算的数据序列
//     * @param operator 求最大还最小值的操作函数
//     * @return /
//     */
//    private Double handleMaxAndMin(List<Double> dataList, BinaryOperator<Double> operator) {
//        if (dataList == null || dataList.isEmpty()) {
//            return 0d;
//        }
//        List<Double> collect = dataList.stream().filter(Objects::nonNull).collect(Collectors.toList());
//        if (collect.isEmpty()) {
//            return 0d;
//        }
//        return collect.stream().reduce(operator).orElse(0d);
//    }
//
//    /**
//     * 构建日期值对象
//     *
//     * @param dateList         日期序列
//     * @param trendTypeListMap 走势图数据
//     * @param trendTypes       走势图类型列表
//     * @return /
//     */
//    private List<Map<String, Object>> buildDateValue(List<String> dateList, Map<TrendType, List<Double>> trendTypeListMap, List<TrendType> trendTypes) {
//        List<Map<String, Object>> dataList = ListUtil.list(true);
//        for (int i = 0; i < dateList.size(); i++) {
//            Map<String, Object> temp = MapUtil.<String, Object>builder("date", dateList.get(i)).build();
//            for (TrendType trendType : trendTypes) {
//                List<Double> doubles = trendTypeListMap.get(trendType);
//                Object value = null;
//                try {
//                    value = i <= doubles.size() ? doubles.get(i) : null;
//                } catch (Exception ignored) {
//                }
//                temp.put(StrUtil.toCamelCase(trendType.name()), value);
//            }
//            dataList.add(temp);
//        }
//        return dataList;
//    }
//
//    /**
//     * 构建dateValue对象列表
//     *
//     * @param dateList  日期序列
//     * @param valueList 值序列
//     * @return /
//     */
//    private List<DateValue> buildDateValue(List<String> dateList, List<Double> valueList) {
//        List<DateValue> dataList = ListUtil.list(true);
//        if (valueList == null) {
//            return dataList;
//        }
//        for (int i = 0; i < dateList.size(); i++) {
//            if (valueList.get(i) == null) {
//                valueList.set(i, i == 0 ? null : valueList.get(i - 1));
//            }
//            if (valueList.get(i) == null) {
//                continue;
//            }
//            dataList.add(new DateValue(dateList.get(i), valueList.get(i)));
//        }
//        return dataList;
//    }
//
//    protected HistoryRetTableSingleResp getHistoryRetTableSingleResp(List<String> secIds, List<String> indexIdList, Map<String, List<IndicatorCalcPropertyDto>> indicatorCalcPropertyDtoListMap,
//                                                                     Indicator indicator, boolean ifExcessReturn, Frequency rollingFrequency) {
//        TimeIntervalDto timeIntervalDto = new TimeIntervalDto();
//        List<String> yearOrYearMonthList = ListUtil.list(true);
//        List<Integer> cates = CATE_LIST_MAP.get(rollingFrequency);
//        List<String> monthOrWeekList = MONTH_WEEK_LIST_MAP.get(rollingFrequency);
//
//        // Map<secId, Map<年或者年月, Map<月或者周, value>>>
//        Map<String, Map<String, Map<String, String>>> secYearMonthValueMapMapMap = new HashMap<>(16);
//        // Map<secId, Map<年或者年月, value>>
//        Map<String, Map<String, String>> secYearValueMapMap = new HashMap<>(16);
//
//        for (String secId : secIds) {
//            List<IndicatorCalcPropertyDto> indicatorCalcPropertyDtoList = indicatorCalcPropertyDtoListMap.get(secId);
//            for (IndicatorCalcPropertyDto indicatorCalcPropertyDto : indicatorCalcPropertyDtoList) {
//                String id = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getId();
//                if (Frequency.Monthly == rollingFrequency || Frequency.Quarterly == rollingFrequency) {
//                    if (YEAR_ROLL_DEFAULT_ID.equals(id)) {
//                        prepareSingleYearDate(secId, indexIdList, indicatorCalcPropertyDto, indicator, secYearValueMapMap, ifExcessReturn);
//                    } else {
//                        prepareSingleMonthDate(secId, indexIdList, indicatorCalcPropertyDto, indicator, timeIntervalDto, yearOrYearMonthList, secYearMonthValueMapMapMap, ifExcessReturn);
//                    }
//                } else if (Frequency.Weekly == rollingFrequency) {
//                    if (MONTH_ROLL_DEFAULT_ID.equals(id)) {
//                        prepareSingleYearMonthDate(secId, indexIdList, indicatorCalcPropertyDto, indicator, secYearValueMapMap, ifExcessReturn);
//                    } else {
//                        prepareSingleWeekDate(secId, indexIdList, indicatorCalcPropertyDto, indicator, timeIntervalDto, yearOrYearMonthList, secYearMonthValueMapMapMap, ifExcessReturn);
//                    }
//                } else if (Frequency.Annually == rollingFrequency) {
//                    prepareSingleYearDate(secId, indexIdList, indicatorCalcPropertyDto, indicator, secYearValueMapMap, ifExcessReturn);
//                    prepareSingleMonthDate(secId, indexIdList, indicatorCalcPropertyDto, indicator, timeIntervalDto, yearOrYearMonthList, secYearMonthValueMapMapMap, ifExcessReturn);
//                }
//            }
//        }
//
//        Collections.sort(yearOrYearMonthList);
//
//        List<HistoryRetTableSingleData> data = new ArrayList<>();
//        for (int i = yearOrYearMonthList.size() - 1; i >= 0; i--) {
//            List<HistoryRetTableSingleRet> rets = new ArrayList<>();
//            String yearOrYearMonth = yearOrYearMonthList.get(i);
//            HistoryRetTableSingleData historyRetTableSingleData = getHistoryRetTableSingleData(secIds, monthOrWeekList,
//                    secYearMonthValueMapMapMap, secYearValueMapMap, rets, yearOrYearMonth, rollingFrequency);
//
//            if (ifExcessReturn) {
//                for (String secId : secIds) {
//                    HistoryRetTableSingleRet extraRet = new HistoryRetTableSingleRet();
//                    List<String> secExtraRetList = new ArrayList<>();
//                    String yearValue = null;
//                    if (secYearValueMapMap.get(secId + EXTRA) != null) {
//                        yearValue = secYearValueMapMap.get(secId + EXTRA).get(yearOrYearMonth);
//                    }
//                    secExtraRetList.add(yearValue);
//                    Map<String, Map<String, String>> yearMonthValueMapMap = secYearMonthValueMapMapMap.get(secId + EXTRA);
//                    Map<String, String> monthValueMap = Optional.ofNullable(yearMonthValueMapMap).map(e -> e.get(yearOrYearMonth)).orElse(null);
//                    List<String> monthList = null;
//                    if (monthValueMap != null) {
//                        monthList = new ArrayList<>(monthValueMap.keySet());
//                    }
//                    for (String monthOrWeek : monthOrWeekList) {
//                        String value = null;
//                        if (monthValueMap != null) {
//                            value = monthValueMap.get(monthOrWeek);
//                            if (value == null && rollingFrequency == Frequency.Quarterly) {
//                                Pair<String, String> pair = MONTH_QUARTERLY_MAP.get(monthOrWeek);
//                                String s = monthList.stream().filter(e -> e.compareTo(pair.getKey()) > 0).filter(e -> e.compareTo(pair.getValue()) < 0)
//                                        .filter(e -> e.compareTo(monthOrWeek) <= 0).max(String::compareTo).orElse(null);
//                                value = s == null ? null : monthValueMap.get(s);
//                            }
//                        }
//                        secExtraRetList.add(value);
//                    }
//                    extraRet.setId(secId);
//                    extraRet.setType("extraRet");
//                    extraRet.setRet(secExtraRetList);
//                    rets.add(extraRet);
//                }
//            }
//
//            calcIndexRet(indexIdList, monthOrWeekList, secYearMonthValueMapMapMap, secYearValueMapMap, data, historyRetTableSingleData, yearOrYearMonth, rets, rollingFrequency);
//        }
//
//        HistoryRetTableSingleResp resp = new HistoryRetTableSingleResp();
//        resp.setData(data);
//        resp.setDatetime(cates);
//        resp.setStartDate(timeIntervalDto.getStartDate());
//        resp.setEndDate(timeIntervalDto.getEndDate());
//        return resp;
//    }
//
//    private HistoryRetTableSingleData getHistoryRetTableSingleData(List<String> secIds, List<String> monthOrWeekList, Map<String, Map<String, Map<String, String>>> secYearMonthValueMapMapMap,
//                                                                   Map<String, Map<String, String>> secYearValueMapMap, List<HistoryRetTableSingleRet> rets, String yearOrYearMonth, Frequency rollingFrequency) {
//        HistoryRetTableSingleData historyRetTableSingleData = new HistoryRetTableSingleData();
//        historyRetTableSingleData.setYear(yearOrYearMonth);
//
//        for (String secId : secIds) {
//            HistoryRetTableSingleRet ret = new HistoryRetTableSingleRet();
//            List<String> secRetList = new ArrayList<>();
//            String yearValue = null;
//            if (secYearValueMapMap.get(secId) != null) {
//                yearValue = secYearValueMapMap.get(secId).get(yearOrYearMonth);
//            }
//
//            secRetList.add(yearValue);
//            Map<String, Map<String, String>> yearMonthValueMapMap = secYearMonthValueMapMapMap.get(secId);
//            Map<String, String> monthValueMap = Optional.ofNullable(yearMonthValueMapMap).map(e -> e.get(yearOrYearMonth)).orElse(null);
//            List<String> monthList = null;
//            if (monthValueMap != null) {
//                monthList = new ArrayList<>(monthValueMap.keySet());
//            }
//            for (String monthOrWeek : monthOrWeekList) {
//                String value = null;
//                if (monthValueMap != null) {
//                    value = monthValueMap.get(monthOrWeek);
//                    if (value == null && rollingFrequency == Frequency.Quarterly) {
//                        Pair<String, String> pair = MONTH_QUARTERLY_MAP.get(monthOrWeek);
//                        String s = monthList.stream().filter(e -> e.compareTo(pair.getKey()) > 0).filter(e -> e.compareTo(pair.getValue()) < 0)
//                                .filter(e -> e.compareTo(monthOrWeek) <= 0).max(String::compareTo).orElse(null);
//                        value = s == null ? null : monthValueMap.get(s);
//                    }
//                }
//                secRetList.add(value);
//            }
//            ret.setId(secId);
//            ret.setType("ret");
//            ret.setRet(secRetList);
//            rets.add(ret);
//        }
//        return historyRetTableSingleData;
//    }
//
//    private void prepareSingleWeekDate(String secId, List<String> indexIdList, IndicatorCalcPropertyDto indicatorCalcPropertyDto, Indicator indicator, TimeIntervalDto timeIntervalDto,
//                                       List<String> yearMonthList, Map<String, Map<String, Map<String, String>>> secYearMonthWeekValueMapMapMap, boolean ifExtraRet) {
//        String startDate1 = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getStartDate();
//        String endDate1 = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getEndDate();
//        if (StrUtil.isBlank(timeIntervalDto.getStartDate()) || startDate1.compareTo(timeIntervalDto.getStartDate()) < 0) {
//            timeIntervalDto.setStartDate(startDate1);
//        }
//        if (StrUtil.isBlank(timeIntervalDto.getEndDate()) || endDate1.compareTo(timeIntervalDto.getEndDate()) > 0) {
//            timeIntervalDto.setEndDate(endDate1);
//        }
//        String calcEndDate = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getEndDate();
//        String yearMonthWeek = CaffeineLocalCache.getDateMonthWeek(calcEndDate);
//        String yearMonth = yearMonthWeek.substring(0, 7);
//        String week = yearMonthWeek.substring(8);
//        if (!yearMonthList.contains(yearMonth)) {
//            yearMonthList.add(yearMonth);
//        }
//        handleMonthWeekYearData(secId, indexIdList, indicatorCalcPropertyDto, indicator, secYearMonthWeekValueMapMapMap, ifExtraRet, yearMonth, week);
//    }
//
//    private void prepareSingleYearDate(String secId, List<String> indexIdList, IndicatorCalcPropertyDto indicatorCalcPropertyDto, Indicator indicator,
//                                       Map<String, Map<String, String>> secYearValueMapMap, boolean ifExcessRet) {
//        String endDate1 = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getEndDate();
//        Date monthDate = DateUtils.addDays(DateUtil.parse(endDate1, DateConst.YYYY_MM_DD), -5);
//        String date = DateUtil.format(monthDate, DateConst.YYYY_MM_DD);
//        String year = date.substring(0, 4);
//        String value = indicatorCalcPropertyDto.getSecData().getIndicatorValueMap().get(indicator.name());
//        if (secYearValueMapMap.containsKey(secId)) {
//            secYearValueMapMap.get(secId).put(year, value);
//        } else {
//            Map<String, String> yearValueMap = new HashMap<>(16);
//            yearValueMap.put(year, value);
//            secYearValueMapMap.put(secId, yearValueMap);
//        }
//        if (Indicator.ExcessReturn == indicator || ifExcessRet) {
//            String extraValue = indicatorCalcPropertyDto.getSecData().getExtraGeoIndicatorValueMap().get(indicator.name());
//            if (secYearValueMapMap.containsKey(secId + EXTRA)) {
//                secYearValueMapMap.get(secId + EXTRA).put(year, extraValue);
//            } else {
//                Map<String, String> yearValueMap = new HashMap<>(16);
//                yearValueMap.put(year, extraValue);
//                secYearValueMapMap.put(secId + EXTRA, yearValueMap);
//            }
//        }
//
//        for (String indexId : indexIdList) {
//            String indexValue = indicatorCalcPropertyDto.getIndexData().getIndexIndicatorValueMap().get(indexId).get(indicator.name());
//            if (secYearValueMapMap.containsKey(indexId)) {
//                secYearValueMapMap.get(indexId).put(year, indexValue);
//            } else {
//                Map<String, String> yearValueMap = new HashMap<>(16);
//                yearValueMap.put(year, indexValue);
//                secYearValueMapMap.put(indexId, yearValueMap);
//            }
//        }
//    }
//
//    private void prepareSingleMonthDate(String secId, List<String> indexIdList, IndicatorCalcPropertyDto indicatorCalcPropertyDto, Indicator indicator,
//                                        TimeIntervalDto timeInterval, List<String> yearList, Map<String, Map<String, Map<String, String>>> secYearMonthValueMapMapMap, boolean ifExcessRet) {
//        String startDate1 = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getStartDate();
//        String endDate1 = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getEndDate();
//        if (StrUtil.isBlank(timeInterval.getStartDate()) || startDate1.compareTo(timeInterval.getStartDate()) < 0) {
//            timeInterval.setStartDate(startDate1);
//        }
//        if (StrUtil.isBlank(timeInterval.getEndDate()) || endDate1.compareTo(timeInterval.getEndDate()) > 0) {
//            timeInterval.setEndDate(endDate1);
//        }
//        String yearMonth = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getId();
//        String year = yearMonth.substring(0, 4);
//        if (!yearList.contains(year)) {
//            yearList.add(year);
//        }
//        String month = yearMonth.substring(5);
//        handleMonthWeekYearData(secId, indexIdList, indicatorCalcPropertyDto, indicator, secYearMonthValueMapMapMap, ifExcessRet, year, month);
//    }
//
//    private void handleMonthWeekYearData(String secId, List<String> indexIdList, IndicatorCalcPropertyDto indicatorCalcPropertyDto,
//                                         Indicator indicator, Map<String, Map<String, Map<String, String>>> secYearMonthValueMapMapMap,
//                                         boolean ifExcessRet, String year, String month) {
//        String value = indicatorCalcPropertyDto.getSecData().getIndicatorValueMap().get(indicator.name());
//        if (secYearMonthValueMapMapMap.containsKey(secId)) {
//            Map<String, Map<String, String>> yearMonthValueMapMap = secYearMonthValueMapMapMap.get(secId);
//            if (yearMonthValueMapMap.containsKey(year)) {
//                Map<String, String> monthValueMap = yearMonthValueMapMap.get(year);
//                monthValueMap.put(month, value);
//            } else {
//                Map<String, String> monthValueMap = new HashMap<>(16);
//                monthValueMap.put(month, value);
//                yearMonthValueMapMap.put(year, monthValueMap);
//            }
//        } else {
//            Map<String, Map<String, String>> yearMonthValueMapMap = new HashMap<>(16);
//            Map<String, String> monthValueMap = new HashMap<>(16);
//            monthValueMap.put(month, value);
//            yearMonthValueMapMap.put(year, monthValueMap);
//            secYearMonthValueMapMapMap.put(secId, yearMonthValueMapMap);
//        }
//        if (Indicator.ExcessReturn == indicator || ifExcessRet) {
//            String extraValue = indicatorCalcPropertyDto.getSecData().getExtraGeoIndicatorValueMap().get(indicator.name());
//            if (secYearMonthValueMapMapMap.containsKey(secId + EXTRA)) {
//                Map<String, Map<String, String>> yearMonthValueMapMap = secYearMonthValueMapMapMap.get(secId + EXTRA);
//                if (yearMonthValueMapMap.containsKey(year)) {
//                    Map<String, String> monthValueMap = yearMonthValueMapMap.get(year);
//                    monthValueMap.put(month, extraValue);
//                } else {
//                    Map<String, String> monthValueMap = new HashMap<>(16);
//                    monthValueMap.put(month, extraValue);
//                    yearMonthValueMapMap.put(year, monthValueMap);
//                }
//            } else {
//                Map<String, Map<String, String>> yearMonthValueMapMap = new HashMap<>(16);
//                Map<String, String> monthValueMap = new HashMap<>(16);
//                monthValueMap.put(month, extraValue);
//                yearMonthValueMapMap.put(year, monthValueMap);
//                secYearMonthValueMapMapMap.put(secId + EXTRA, yearMonthValueMapMap);
//            }
//        }
//        for (String index : indexIdList) {
//            String indexValue = indicatorCalcPropertyDto.getIndexData().getIndexIndicatorValueMap().get(index).get(indicator.name());
//            if (secYearMonthValueMapMapMap.containsKey(index)) {
//                Map<String, Map<String, String>> yearMonthValueMapMap = secYearMonthValueMapMapMap.get(index);
//                if (yearMonthValueMapMap.containsKey(year)) {
//                    Map<String, String> monthValueMap = yearMonthValueMapMap.get(year);
//                    monthValueMap.put(month, indexValue);
//                } else {
//                    Map<String, String> monthValueMap = new HashMap<>(16);
//                    monthValueMap.put(month, indexValue);
//                    yearMonthValueMapMap.put(year, monthValueMap);
//                }
//            } else {
//                Map<String, Map<String, String>> yearMonthValueMapMap = new HashMap<>(16);
//                Map<String, String> monthValueMap = new HashMap<>(16);
//                monthValueMap.put(month, indexValue);
//                yearMonthValueMapMap.put(year, monthValueMap);
//                secYearMonthValueMapMapMap.put(index, yearMonthValueMapMap);
//            }
//        }
//    }
//
//    private void prepareSingleYearMonthDate(String secId, List<String> indexIdList, IndicatorCalcPropertyDto indicatorCalcPropertyDto, Indicator indicator,
//                                            Map<String, Map<String, String>> secMonthValueMapMap, boolean ifExtraRet) {
//        String endDate1 = indicatorCalcPropertyDto.getIndicatorCalcReq().getIndicatorCalcTimeRangeDto().getEndDate();
//        Date monthDate = DateUtils.addDays(DateUtil.parse(endDate1, DateConst.YYYY_MM_DD), -5);
//        String date = DateUtil.format(monthDate, DateConst.YYYY_MM_DD);
//        String yearMonth = date.substring(0, 7);
//        String value = indicatorCalcPropertyDto.getSecData().getIndicatorValueMap().get(indicator.name());
//
//        if (secMonthValueMapMap.containsKey(secId)) {
//            secMonthValueMapMap.get(secId).put(yearMonth, value);
//        } else {
//            Map<String, String> yearValueMap = new HashMap<>(16);
//            yearValueMap.put(yearMonth, value);
//            secMonthValueMapMap.put(secId, yearValueMap);
//        }
//
//        if (Indicator.ExcessReturn == indicator || ifExtraRet) {
//            String extraValue = indicatorCalcPropertyDto.getSecData().getExtraGeoIndicatorValueMap().get(indicator.name());
//            if (secMonthValueMapMap.containsKey(secId + EXTRA)) {
//                secMonthValueMapMap.get(secId + EXTRA).put(yearMonth, extraValue);
//            } else {
//                Map<String, String> yearValueMap = new HashMap<>(16);
//                yearValueMap.put(yearMonth, extraValue);
//                secMonthValueMapMap.put(secId + EXTRA, yearValueMap);
//            }
//        }
//
//        //指数的
//        for (String indexId : indexIdList) {
//            String indexValue = indicatorCalcPropertyDto.getIndexData().getIndexIndicatorValueMap().get(indexId).get(indicator.name());
//            if (secMonthValueMapMap.containsKey(indexId)) {
//                secMonthValueMapMap.get(indexId).put(yearMonth, indexValue);
//            } else {
//                Map<String, String> yearValueMap = new HashMap<>(16);
//                yearValueMap.put(yearMonth, indexValue);
//                secMonthValueMapMap.put(indexId, yearValueMap);
//            }
//        }
//    }
//
//    protected Map<String, Map<String, Double>> findRetData(List<Map<String, Object>> dataList, String start, String end) {
//        Map<String, Map<String, Double>> map = MapUtil.newHashMap();
//        for (Map<String, Object> m : dataList) {
//            if (null == m) {
//                continue;
//            }
//            String endDate = m.get("end_date") + "";
//            if (start.compareTo(endDate) <= 0 && end.compareTo(endDate) >= 0) {
//                String fundId = m.get("fund_id") + "";
//                Object retRange = m.get("ret_range");
//                Double ret = null;
//                if (null != retRange) {
//                    try {
//                        ret = Double.parseDouble(retRange + "");
//                    } catch (Exception e) {
//                        e.printStackTrace();
//                    }
//                } else {
//                    continue;
//                }
//                Map<String, Double> dataMap = map.getOrDefault(fundId, new LinkedHashMap<>());
//                dataMap.put(endDate, ret);
//                map.put(fundId, dataMap);
//            }
//        }
//        return map;
//    }
//
//    private void calcIndexRet(List<String> indexIdList, List<String> monthOrWeekList, Map<String, Map<String, Map<String, String>>> secYearMonthValueMapMapMap,
//                              Map<String, Map<String, String>> secYearValueMapMap, List<HistoryRetTableSingleData> data,
//                              HistoryRetTableSingleData historyRetTableSingleData, String yearOrYearMonth, List<HistoryRetTableSingleRet> rets, Frequency rollingFrequency) {
//        for (String indexId : indexIdList) {
//            HistoryRetTableSingleRet indexRet = new HistoryRetTableSingleRet();
//            List<String> indexRetList = new ArrayList<>();
//            String yearValue = null;
//            if (secYearValueMapMap.get(indexId) != null) {
//                yearValue = secYearValueMapMap.get(indexId).get(yearOrYearMonth);
//            }
//            indexRetList.add(yearValue);
//            Map<String, Map<String, String>> yearMonthValueMapMap = secYearMonthValueMapMapMap.get(indexId);
//            Map<String, String> monthValueMap = Optional.ofNullable(yearMonthValueMapMap).map(e -> e.get(yearOrYearMonth)).orElse(null);
//            List<String> monthList = null;
//            if (monthValueMap != null) {
//                monthList = new ArrayList<>(monthValueMap.keySet());
//            }
//            for (String monthOrWeek : monthOrWeekList) {
//                String value = null;
//                if (monthValueMap != null) {
//                    value = monthValueMap.get(monthOrWeek);
//                    if (value == null && rollingFrequency == Frequency.Quarterly) {
//                        Pair<String, String> pair = MONTH_QUARTERLY_MAP.get(monthOrWeek);
//                        String s = monthList.stream().filter(e -> e.compareTo(pair.getKey()) > 0).filter(e -> e.compareTo(pair.getValue()) < 0)
//                                .filter(e -> e.compareTo(monthOrWeek) <= 0).max(String::compareTo).orElse(null);
//                        value = s == null ? null : monthValueMap.get(s);
//                    }
//                }
//                indexRetList.add(value);
//            }
//            indexRet.setId(indexId);
//            indexRet.setType("ret");
//            indexRet.setRet(indexRetList);
//            rets.add(indexRet);
//        }
//        historyRetTableSingleData.setRets(rets);
//        data.add(historyRetTableSingleData);
//    }
//}
