//package com.smppw.analysis.domain.manager.performance;
//
//import cn.hutool.core.collection.ListUtil;
//import com.smppw.analysis.domain.dto.performance.*;
//import com.smppw.common.pojo.enums.Indicator;
//import com.smppw.common.pojo.enums.TimeRange;
//import com.smppw.common.pojo.enums.TrendType;
//
//import java.util.List;
//import java.util.Map;
//
///**
// * @author wangzaijun
// * @date 2023/3/10 17:51
// * @description 业绩表现接口，包括基金、机构和基金经理
// */
//public interface PerformanceService {
//    /**
//     * 计算收益风险指标，包括部分几何指标
//     *
//     * @param params /
//     * @return /
//     */
//    default Map<String, Object> rateRiskIndicators(IndicatorParams params) {
//        return this.rateRiskIndicators(params, ListUtil.toList(Indicator.INDICATOR_TYPE_ARRAY), ListUtil.toList(Indicator.RISK_TABLE_EXCESS_INDICATOR_ARRAY));
//    }
//
//    Map<String, Object> rateRiskIndicators(IndicatorParams params, List<Indicator> indicators, List<Indicator> geoIndicators);
//
//    /**
//     * 动态回撤 接口业务，返回回撤、超额回撤、最大回撤和最大超额回撤
//     *
//     * @param params /
//     * @return /
//     */
//    default Map<String, Object> dynamicDown(TrendParams params) {
//        return this.dynamicDown(params, null);
//    }
//
//    /**
//     * 动态回撤 接口业务，返回回撤、超额回撤、最大回撤和最大超额回撤
//     *
//     * @param params /
//     * @return /
//     */
//    Map<String, Object> dynamicDown(TrendParams params, String masterId);
//
//    /**
//     * 业绩走势接口业务处理
//     *
//     * @param params 请求参数
//     * @return /
//     */
//    default Map<String, Object> trend(TrendParams params) {
//        List<TrendType> trendTypes = ListUtil.toList(TrendType.Ret, TrendType.Nav, TrendType.ExtraNav, TrendType.OrigNav, TrendType.ExtraRetAri, TrendType.NetValueChange, TrendType.ExtraRetGeo, TrendType.DrawdownTrend);
//        List<TrendType> indexTrendTypes = ListUtil.toList(TrendType.Ret, TrendType.OrigNav);
//        return this.trend(params, trendTypes, indexTrendTypes);
//    }
//
//    /**
//     * 业绩走势接口业务处理
//     *
//     * @param params          请求参数
//     * @param trendTypes      标的走势图类型列表
//     * @param indexTrendTypes 指数走势图类型列表
//     * @return /
//     */
//    Map<String, Object> trend(TrendParams params, List<TrendType> trendTypes, List<TrendType> indexTrendTypes);
//
//    /**
//     * 货币基金业绩走势
//     *
//     * @param params /
//     * @return /
//     */
//    Map<String, Object> imfTrend(ImfTrendParams params);
//
//    /**
//     * 业绩排名 接口请求业务处理
//     *
//     * @param params 请求参数
//     * @return /
//     */
//    Map<String, Object> rank(RankParams params);
//
//    /**
//     * 区间指标分析 接口请求业务处理
//     *
//     * @param params 请求参数
//     * @return /
//     */
//    default Map<String, Object> rangIndicator(RangIndicatorParams params) {
//        return this.rangIndicator(params, null);
//    }
//
//
//    /**
//     * 区间指标分析 接口请求业务处理
//     *
//     * @param params   请求参数
//     * @param rangeMap 返回结果映射函数
//     * @return /
//     */
//    Map<String, Object> rangIndicator(RangIndicatorParams params, Map<TimeRange, String> rangeMap);
//
//    /**
//     * 滚动指标分析 接口请求业务处理，不支持多标的
//     *
//     * @param params 请求参数
//     * @return /
//     */
//    Map<String, Object> rollIndicator(RollIndicatorParams params);
//
//    /**
//     * 收益统计/收益分布 接口请求业务处理
//     *
//     * @param params 请求参数
//     * @return /
//     */
//    Map<String, Object> revenue(RevenueParams params);
//
//    /**
//     * 胜率分析，只支持单标的 业务处理
//     *
//     * @param params /
//     * @return /
//     */
//    Map<String, Object> win(WinParams params);
//
//    /**
//     * 指标分析
//     *
//     * @param params
//     * @return
//     */
//    Map<String, Object> analyzeIndicatorNew(RangIndicatorParams params);
//
//    /**
//     * 相关性
//     *
//     * @param params
//     * @return
//     */
//    Map<String, Object> analyzeCovNew(AnalyzeCovParams params);
//}
